<template>
  <div>
    <v-card>
      <v-toolbar 
        color="secondary" 
        dark>
        <v-icon>business</v-icon>
        <v-toolbar-title>
          <span class="hidden-sm-and-down mr-3">File manager</span>
        </v-toolbar-title>

        <v-btn-toggle 
          v-model="storage.type" 
          mandatory>
          <v-tooltip bottom>
            <v-btn 
              slot="activator" 
              :disabled="!storage.have_local" 
              flat>
              <v-icon>storage</v-icon>
            </v-btn>
            <span>Local storage</span>
          </v-tooltip>
          <v-tooltip bottom>
            <v-btn 
              slot="activator" 
              :disabled="!storage.have_sdcard" 
              flat>
              <v-icon>sd_storage</v-icon>
            </v-btn>
            <span>SD card</span>
          </v-tooltip>
          <v-tooltip bottom>
            <v-btn 
              slot="activator" 
              :disabled="!storage.have_usb" 
              flat>
              <v-icon>usb</v-icon>
            </v-btn>
            <span>USB drive</span>
          </v-tooltip>
        </v-btn-toggle>

        <v-spacer/>
        <v-btn 
          round 
          color="primary"
          dark
          @click="showUploadFiles"
        >Upload</v-btn>

        <!--
                                 <v-menu offset-y>
                  <v-btn flat round
                    slot="activator"
                  >
                    <v-icon>add</v-icon> NEW
                  </v-btn>
                  <v-list>
                       <v-list-tile
                          @click=""
                        >
                          <v-list-tile-title>Folder</v-list-tile-title>
                        </v-list-tile>
                       <v-list-tile
                          @click=""
                        >
                          <v-list-tile-title>File upload</v-list-tile-title>
                        </v-list-tile>
                  </v-list>
              </v-menu> -->
      </v-toolbar>
    </v-card>
    <!-- section:custom_view -->
    <v-toolbar dense>

      <v-breadcrumbs>
        <v-icon slot="divider">chevron_right</v-icon>
        <v-breadcrumbs-item
          v-for="bc in breadcrumbs"
          :key="bc.text"
          :append="true"
          :to="bc.to"
          :exact="true"
        >
          <span v-if="!bc.icon">
            {{ bc.text }}
          </span>
          <span v-else>
            <v-icon>storage</v-icon>
          </span>
                    
        </v-breadcrumbs-item>
      </v-breadcrumbs>

      <v-spacer/>

      <v-tooltip bottom>
        <v-btn 
          slot="activator"
          icon
          @click="showCreateFolder"
        >
          <v-icon>create_new_folder</v-icon>
        </v-btn>
        <span>New folder</span>
      </v-tooltip>

      <v-tooltip bottom>
        <v-btn 
          slot="activator"
          icon
          @click="toggleView"
        >
          <v-icon v-if="view == 'list'">
            view_list
          </v-icon>
          <v-icon v-else>
            view_module
          </v-icon>
        </v-btn>
        <span v-if="view == 'list'">Switch to tree view</span>
        <span v-else>Switch to list view</span>
      </v-tooltip>

    </v-toolbar>

    <file-list-view 
      v-if="view == 'list'" 
      :items="files" 
      :storage="storage.name"
      @delete="showDeleteFile"
      @download="downloadFile"
    />

    <file-icon-view 
      v-else-if="view == 'tree'" 
      :items="files" 
      :storage="storage.name"
    />

    <delete-dialog
      @submit="deleteFile"
    />

    <create-folder-dialog
      @submit="createFolder"
    />

    <upload-dialog
      :accept="accept"
      multiple
      @submit="uploadFiles"
    />

    <progress-dialog 
    	:value="progress"
    	:message="message"
    	indeterminate
    />

    <!-- endsection:custom_view -->
  </div>

</template>

<script>
// section:custom_imports
import API from '@api'
import endpoints from '@api/endpoints'
import FileListView from '@components/FileListView'
import FileIconView from '@components/FileIconView'

import DeleteDialog from './Components/DeleteDialog'
import CreateFolderDialog from './Components/CreateFolderDialog'
import UploadDialog from './Components/UploadDialog'
import ProgressDialog from './Components/ProgressDialog'
// endsection:custom_imports
    
import {bus} from '@js/bus'

export default {

	components: {
		// section:custom_components
		FileListView,
		FileIconView,
		DeleteDialog,
		CreateFolderDialog,
		UploadDialog,
		ProgressDialog
		// endsection:custom_components
	},
        
	props:{
		storageType: {
			type: String,
			default: 'local'
		},
		fileId: {
			type: [String, Number],
			default: null
		}
	},

	data() {
		// section:custom_before_data
		let typeId = 0
		let newStorageType = this.storageType

		switch(this.storageType) {
		case 'local':
			typeId = 0
			break
		case 'sdcard':
			typeId = 1
			break
		case 'usb':
			typeId = 2
			break
		default:
			typeId = 0
			newStorageType = 'local'
		}

		this.$router.push( {name: 'storage', params: {storageType:newStorageType, fileId:this.fileId}} )

		// endsection:custom_before_data
		return {
			// section:custom_data
			storage: {
				name: newStorageType,
				type: typeId,
				have_local: true,
				have_sdcard: true,
				have_usb: true
			},
			view: 'list',
			directory: {},
			currentPath: [],
			progress: 0,
			message: 'Uploading files'
			// endsection:custom_data
		}
	},

	computed: {
		// section:custom_computed
		breadcrumbs() {
			var path = []

			path.push({
				text: 'ROOT',
				icon: true,
				disabled: false,
				to: {
					name: 'storage',
					params: {
						storage: this.storageType,
						fileId: null
					}
				}
			})

			if(this.directory.path === undefined)
				return path

			this.directory.path.forEach( function(el) {
				path.push({
					text: el.name,
					disabled: false,
					to: {
						name: 'storage',
						params: {
							storage: this.storageType,
							fileId: el.id
						}
					}
				})
			}, this)
			// ,this) makes this within foreach callback to be the same as
			// this outside of it, at the same time it allows path variable
			// to be updated outside of forEach scope

			if(this.directory.id != null) {
				path.push({
					text: this.directory.name,
					icon: false,
					disabled: false,
					to: {
						name: 'storage',
						params: {
							storage: this.storageType,
							fileId: this.directory.id 
						}
					}
				})
			}

			return path
		},

		files() {
			return this.directory.files
		},

		accept() {
			return '.gcode,.gc,.GCODE'
		}
		// endsection:custom_computed
	},

	created() {
		//this.loadFiles()
		//console.log('queries', this.$smartapi.queries)
		//this.$smartapi.queries.directory.refetch()
	},

	methods: {
		// section:custom_methods
		toggleView() {
			if(this.view == 'list')
				this.view = 'tree'
			else
				this.view = 'list'
		},

		showDeleteFile(file) {
			bus.$emit('remove-file', file)
		},

		deleteFile(file) {
			console.log('deleteFile', file)

			this.message = 'Removing files'
			bus.$emit('show-progress')

			this.$smartapi.delete({
				url: endpoints.files_delete_url,
				variables: {
					storage: this.storageType,
					id: file.id
				},
				update: (cache, deleted, url) => {
					console.log('mutation:update', deleted, url)
					const updated = this.directory.files.filter( file => file.id !== deleted.id )
					this.directory.files = updated                        
				}
			})
				.then(result => {
					bus.$emit('hide-progress')
					bus.$emit('show-popup', {message: 'Deleted successfully', color:'success'})
				})
				.catch(error => {
					bus.$emit('hide-progress')
					bus.$emit('show-popup', {message: 'Failed to deleted "'+file.name+file.ext+'"', color: 'error'})
				})
		},

		renameFile(file, newname) {
			console.log('renameFile', file, newname)
			this.$smartapi.update({
				url: endpoints.files_update_url,
				variables: {
					storage: this.storageType,
					id: file.id
				},
				data: {
					name: newname
				},

			})
		},

		downloadFile(file) {

		},

		showCreateFolder() {
			bus.$emit('create-folder')
		},

		createFolder(folder) {
			console.log('createFolder', folder.name)
			this.$smartapi.create({
				url: endpoints.files_create_url,
				variables: {
					storage: this.storageType
				},
				data: {
					name: folder.name,
					parent_id: this.fileId,
					is_directory: true
				},
				update: (cache, newfolder, url) => {
					console.log('mutation:update', newfolder, url)
					this.directory.files.push(newfolder)
				}
			})
				.then(result => {
					bus.$emit('show-popup', {message: 'Folder create successfully', color:'success'})
				})
				.catch(error => {
					bus.$emit('show-popup', {message: 'Failed to create folder "'+folder.name+'"', color: 'error'})
				})

		},

		showUploadFiles() {
			bus.$emit('upload-files', {
				parent_id: this.fileId
			})
		},

		/*fileSelectedFunc(files) {
			console.log('files:', files)
		},*/

		uploadFiles(bulk) {
			console.log('files:', bulk)

			this.message = 'Uploading files'
			bus.$emit('show-progress')

            this.$smartapi.upload({
            	url: endpoints.files_upload_url,
            	variables: {
            		storage: this.storageType
            	},
            	data: {
            		parent_id: bulk.parent_id
            	},
            	files: bulk.files,
				update: (cache, newfiles, url) => {
					console.log('mutation:update', newfiles, url)
					for(let i in newfiles) {
						let newfile = newfiles[i]
						this.directory.files.push(newfile)
					}
					
				}
            })
				.then(result => {
					bus.$emit('hide-progress')
					bus.$emit('show-popup', {message: 'Upload completed', color:'success'})
				})
				.catch(error => {
					bus.$emit('hide-progress')
					bus.$emit('show-popup', {message: 'Upload failed', color: 'error'})
				})
		},

		// endsection:custom_methods
	},

	api: {
		directory: {
			url() {
				if(this.fileId)
					return endpoints.files_query_url
				else
					return endpoints.files_root_url
			},
			variables() {
				return {
					storage: 'local',
					id: this.fileId
				}
			},
		}
	},

}

</script>